using System.Security.Claims;
using Application.Abstractions.Messaging;
using Web.Api.Common;
using Web.Api.Extensions;

namespace Web.Api.Endpoints.MyPage;

internal sealed class ChangeSummary : IEndpoint
{
    public sealed record Request(string Summary);

    public void MapEndpoint(IEndpointRouteBuilder app)
    {
        app.MapPost("api/mypage/summary", async (
            Request request,
            ClaimsPrincipal user,
            ISender sender,
            CancellationToken ct
        ) => {
            var memberID = user.GetMemberID();

            if (memberID is null)
            {
                return ApiResponse.Fail(StatusCodes.Status401Unauthorized, "Invalid token");
            }

            var command = new Application.Features.Api.MyPage.ChangeSummary.Command(
                memberID.Value,
                request.Summary
            );

            var result = await sender.Send(command, ct);

            return result.Match(
                () => ApiResponse.Ok(),
                CustomResults.Problem
            );
        })
        .WithTags("MyPage")
        .RequireAuthorization();
    }
}